]> git.saurik.com Git - apt.git/blob - test/integration/framework
test: show the highlevel test for lowerranking ones
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
12 else
13 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
14 fi
15 shift
16 done
17 export MSGLEVEL="${MSGLEVEL:-3}"
18
19 # we all like colorful messages
20 if [ "$MSGCOLOR" != 'NO' ] && [ "$MSGCOLOR" != 'ALWAYS' ]; then
21 if [ ! -t 1 ]; then # but check that we output to a terminal
22 export MSGCOLOR='NO'
23 fi
24 fi
25
26
27 if [ "$MSGCOLOR" != 'NO' ]; then
28 CERROR="\033[1;31m" # red
29 CWARNING="\033[1;33m" # yellow
30 CMSG="\033[1;32m" # green
31 CINFO="\033[1;96m" # light blue
32 CDEBUG="\033[1;94m" # blue
33 CNORMAL="\033[0;39m" # default system console color
34 CDONE="\033[1;32m" # green
35 CPASS="\033[1;32m" # green
36 CFAIL="\033[1;31m" # red
37 CCMD="\033[1;35m" # pink
38 fi
39
40 msgprintf() {
41 local START="$1"
42 local MIDDLE="$2"
43 local END="$3"
44 shift 3
45 if [ -n "$1" ]; then
46 printf "$START " "$1"
47 shift
48 while [ -n "$1" ]; do
49 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
50 shift
51 done
52 fi
53 printf "${END}"
54 }
55 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
56 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
57 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
58 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
59 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
60 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
61 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
62 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
63 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
64 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
65 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
66 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
67 msgskip() {
68 if [ -n "$MSGTEST_MSG" ]; then
69 echo -n "$MSGTEST_MSG"
70 unset MSGTEST_MSG
71 fi
72 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
73 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
74 }
75 msgfail() {
76 if [ -n "$MSGTEST_MSG" ]; then
77 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
78 echo "Part of the test group: $MSGTEST_GRP"
79 fi
80 echo -n "$MSGTEST_MSG"
81 unset MSGTEST_MSG
82 fi
83 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
84 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
85 if [ -n "$APT_DEBUG_TESTS" ]; then
86 $SHELL
87 fi
88 EXIT_CODE=$((EXIT_CODE+1));
89 }
90 MSGGROUP_LEVEL=0
91 msggroup() {
92 if [ -n "$1" ]; then
93 if [ $MSGGROUP_LEVEL = 0 ]; then
94 MSGTEST_GRP='NEXT'
95 fi
96 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
97 else
98 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
99 if [ $MSGGROUP_LEVEL = 0 ]; then
100 unset MSGTEST_GRP
101 fi
102 fi
103 }
104
105 # enable / disable Debugging
106 if [ $MSGLEVEL -le 0 ]; then
107 msgdie() { true; }
108 fi
109 if [ $MSGLEVEL -le 1 ]; then
110 msgwarn() { true; }
111 msgnwarn() { true; }
112 fi
113 if [ $MSGLEVEL -le 2 ]; then
114 msgmsg() { true; }
115 msgnmsg() { true; }
116 msgtest() {
117 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
118 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
119 MSGTEST_GRP="$MSGTEST_MSG"
120 fi
121 }
122 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
123 fi
124 if [ $MSGLEVEL -le 3 ]; then
125 msginfo() { true; }
126 msgninfo() { true; }
127 fi
128 if [ $MSGLEVEL -le 4 ]; then
129 msgdebug() { true; }
130 msgndebug() { true; }
131 fi
132 msgdone() {
133 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
134 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
135 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
136 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
137 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
138 true;
139 else
140 printf "${CDONE}DONE${CNORMAL}\n";
141 fi
142 }
143 getaptconfig() {
144 if [ -f ./aptconfig.conf ]; then
145 echo "$(readlink -f ./aptconfig.conf)"
146 elif [ -f ../aptconfig.conf ]; then
147 echo "$(readlink -f ../aptconfig.conf)"
148 elif [ -f ../../aptconfig.conf ]; then
149 echo "$(readlink -f ../../aptconfig.conf)"
150 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
151 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
152 fi
153 }
154 runapt() {
155 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
156 local CMD="$1"
157 shift
158 case $CMD in
159 sh|aptitude|*/*|command) ;;
160 *) CMD="${BUILDDIRECTORY}/$CMD";;
161 esac
162 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
163 }
164 aptconfig() { runapt apt-config "$@"; }
165 aptcache() { runapt apt-cache "$@"; }
166 aptcdrom() { runapt apt-cdrom "$@"; }
167 aptget() { runapt apt-get "$@"; }
168 aptftparchive() { runapt apt-ftparchive "$@"; }
169 aptkey() { runapt apt-key "$@"; }
170 aptmark() { runapt apt-mark "$@"; }
171 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
172 apt() { runapt apt "$@"; }
173 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
174 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
175 aptitude() { runapt aptitude "$@"; }
176 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
177 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
178 aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
179
180 dpkg() {
181 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
182 }
183 dpkgcheckbuilddeps() {
184 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
185 }
186 gdb() {
187 local CMD
188 case "$1" in
189 aptget) CMD="apt-get";;
190 aptcache) CMD="apt-cache";;
191 aptcdrom) CMD="apt-cdrom";;
192 aptconfig) CMD="apt-config";;
193 aptmark) CMD="apt-mark";;
194 apthelper) CMD="apt-helper";;
195 aptftparchive) CMD="apt-ftparchive";;
196 *) CMD="$1";;
197 esac
198 shift
199 runapt command gdb --quiet -ex run "${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
200 }
201
202 exitwithstatus() {
203 # error if we about to overflow, but ...
204 # "255 failures ought to be enough for everybody"
205 if [ $EXIT_CODE -gt 255 ]; then
206 msgdie "Total failure count $EXIT_CODE too big"
207 fi
208 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
209 }
210
211 shellsetedetector() {
212 local exit_status=$?
213 if [ "$exit_status" != '0' ]; then
214 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
215 if [ "$EXIT_CODE" = '0' ]; then
216 EXIT_CODE="$exit_status"
217 fi
218 fi
219 }
220
221 addtrap() {
222 if [ "$1" = 'prefix' ]; then
223 CURRENTTRAP="$2 $CURRENTTRAP"
224 else
225 CURRENTTRAP="$CURRENTTRAP $1"
226 fi
227 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
228 }
229
230 setupenvironment() {
231 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
232 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
233 unset TMPDIR
234 fi
235 TMPWORKINGDIRECTORY=$(mktemp -d)
236 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
237 msgninfo "Preparing environment for $(basename $0) in ${TMPWORKINGDIRECTORY}…"
238
239 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
240 if [ "$(id -u)" = '0' ]; then
241 # relax permissions so that running as root with user switching works
242 umask 022
243 chmod 711 "$TMPWORKINGDIRECTORY"
244 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
245 fi
246
247 TESTDIRECTORY=$(readlink -f $(dirname $0))
248 # allow overriding the default BUILDDIR location
249 SOURCEDIRECTORY=${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}
250 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
251 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
252 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
253 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
254 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
255 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
256 APTDUMPSOLVER=${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}
257 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
258 # -----
259
260 cd $TMPWORKINGDIRECTORY
261 mkdir rootdir aptarchive keys
262 cd rootdir
263 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
264 mkdir -p usr/bin var/cache var/lib var/log tmp
265 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
266 touch var/lib/dpkg/available
267 mkdir -p usr/lib/apt
268 ln -s ${METHODSDIR} usr/lib/apt/methods
269 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
270 mkdir -p usr/lib/apt/solvers
271 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
272 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
273 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
274 fi
275 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
276 # system
277 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
278 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
279 else
280 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
281 fi
282 cd ..
283 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
284 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
285 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
286 fi
287 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
288 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
289 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
290 fi
291 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
292 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
293 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
294
295 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
296 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
297 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
298 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
299 # store apt-key were we can access it, even if we run it as a different user
300 # destroys coverage reporting though, so just do it for root for now
301 if [ "$(id -u)" = '0' ]; then
302 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
303 chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
304 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
305 else
306 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
307 fi
308
309 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
310 #!/bin/sh
311 set -e
312 if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
313 if [ -n "\$LD_PRELOAD" ]; then
314 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
315 else
316 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
317 fi
318 fi
319 exec fakeroot dpkg --root="${TMPWORKINGDIRECTORY}/rootdir" \\
320 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
321 --force-not-root --force-bad-path "\$@"
322 EOF
323 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
324 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
325
326 {
327 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
328 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
329 fi
330 echo 'quiet::NoUpdate "true";'
331 echo 'quiet::NoStatistic "true";'
332 # too distracting for users, but helpful to detect changes
333 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
334 echo 'Acquire::Progress::Diffpercent "true";'
335 # in testcases, it can appear as if localhost has a rotation setup,
336 # hide this as we can't really deal with it properly
337 echo 'Acquire::Failure::ShowIP "false";'
338 } >> aptconfig.conf
339
340 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
341 if [ "$(id -u)" = '0' ]; then
342 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
343 fi
344 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
345 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
346 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
347
348 # create some files in /tmp and look at user/group to get what this means
349 TEST_DEFAULT_USER="$USER"
350 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
351 TEST_DEFAULT_GROUP='root'
352 else
353 TEST_DEFAULT_GROUP="$USER"
354 fi
355
356 # Acquire::AllowInsecureRepositories=false is not yet the default
357 # but we want it to be the default soon
358 configallowinsecurerepositories "false";
359
360 # cleanup the environment a bit
361 # prefer our apt binaries over the system apt binaries
362 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
363 export LC_ALL=C.UTF-8
364 unset LANGUAGE APT_CONFIG
365 unset GREP_OPTIONS DEB_BUILD_PROFILES
366 msgdone "info"
367 }
368
369 getarchitecture() {
370 if [ "$1" = "native" -o -z "$1" ]; then
371 eval `aptconfig shell ARCH APT::Architecture`
372 if [ -n "$ARCH" ]; then
373 echo $ARCH
374 else
375 dpkg --print-architecture
376 fi
377 else
378 echo $1
379 fi
380 }
381
382 getarchitectures() {
383 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
384 }
385
386 getarchitecturesfromcommalist() {
387 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
388 }
389
390 configarchitecture() {
391 {
392 echo "APT::Architecture \"$(getarchitecture $1)\";"
393 while [ -n "$1" ]; do
394 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
395 shift
396 done
397 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
398 configdpkg
399 }
400
401 configdpkg() {
402 if [ ! -e rootdir/var/lib/dpkg/status ]; then
403 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
404 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
405 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
406 else
407 echo -n > rootdir/var/lib/dpkg/status
408 fi
409 fi
410 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
411 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
412 local ARCHS="$(getarchitectures)"
413 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
414 DPKGARCH="$(dpkg --print-architecture)"
415 for ARCH in ${ARCHS}; do
416 if [ "${ARCH}" != "${DPKGARCH}" ]; then
417 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
418 # old-style used e.g. in Ubuntu-P – and as it seems travis
419 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
420 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
421 fi
422 fi
423 done
424 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
425 # dpkg doesn't really check the version as long as it is fully installed,
426 # but just to be sure we choose one above the required version
427 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
428 fi
429 fi
430 fi
431 }
432
433 configdpkgnoopchroot() {
434 # create a library to noop chroot() and rewrite maintainer script executions
435 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
436 # chroot directory dpkg could chroot into to execute the maintainer scripts
437 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
438 cat << EOF > noopchroot.c
439 #define _GNU_SOURCE
440 #include <stdio.h>
441 #include <stdlib.h>
442 #include <string.h>
443 #include <dlfcn.h>
444
445 static char * chrootdir = NULL;
446
447 int chroot(const char *path) {
448 printf("WARNING: CHROOTing to %s was ignored!\n", path);
449 free(chrootdir);
450 chrootdir = strdup(path);
451 return 0;
452 }
453 int execvp(const char *file, char *const argv[]) {
454 static int (*func_execvp) (const char *, char * const []) = NULL;
455 if (func_execvp == NULL)
456 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
457 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
458 return func_execvp(file, argv);
459 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
460 char newfile[strlen(chrootdir) + strlen(file)];
461 strcpy(newfile, chrootdir);
462 strcat(newfile, file);
463 char const * const baseadmindir = "/var/lib/dpkg";
464 char admindir[strlen(chrootdir) + strlen(baseadmindir)];
465 strcpy(admindir, chrootdir);
466 strcat(admindir, baseadmindir);
467 setenv("DPKG_ADMINDIR", admindir, 1);
468 return func_execvp(newfile, argv);
469 }
470 EOF
471 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
472 }
473
474 configallowinsecurerepositories() {
475 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
476
477 }
478
479 configcompression() {
480 while [ -n "$1" ]; do
481 case "$1" in
482 '.') printf ".\t.\tcat\n";;
483 'gz') printf "gzip\tgz\tgzip\n";;
484 'bz2') printf "bzip2\tbz2\tbzip2\n";;
485 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
486 'xz') printf "xz\txz\txz\n";;
487 *) printf "$1\t$1\t$1\n";;
488 esac
489 shift
490 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
491 }
492
493 forcecompressor() {
494 COMPRESSOR="$1"
495 COMPRESSOR_CMD="$1"
496 case $COMPRESSOR in
497 gzip) COMPRESS='gz';;
498 bzip2) COMPRESS='bz2';;
499 lzma) COMPRESS='lzma';;
500 xz) COMPRESS='xz';;
501 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
502 esac
503 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
504 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
505 Dir::Bin::uncompressed \"/does/not/exist\";
506 Dir::Bin::gzip \"/does/not/exist\";
507 Dir::Bin::bzip2 \"/does/not/exist\";
508 Dir::Bin::lzma \"/does/not/exist\";
509 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
510 if [ -e "/bin/${COMPRESSOR}" ]; then
511 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
512 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
513 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
514 elif [ "${COMPRESSOR}" = 'lzma' ]; then
515 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
516 COMPRESSOR_CMD='xz --format=lzma'
517 else
518 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
519 msgfail "${COMPRESSOR} not available"
520 fi
521 }
522
523 setupsimplenativepackage() {
524 local NAME="$1"
525 local ARCH="$2"
526 local VERSION="$3"
527 local RELEASE="${4:-unstable}"
528 local DEPENDENCIES="$5"
529 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
530 If you find such a package installed on your system,
531 something went horribly wrong! They are autogenerated
532 und used only by testcases and surf no other propose…"}"
533
534 local SECTION="${7:-others}"
535 local DISTSECTION
536 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
537 DISTSECTION="main"
538 else
539 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
540 fi
541 local BUILDDIR=incoming/${NAME}-${VERSION}
542 mkdir -p ${BUILDDIR}/debian/source
543 cd ${BUILDDIR}
544 echo "* most suckless software product ever" > FEATURES
545 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
546 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
547
548 * Initial release
549
550 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
551 test -e debian/control || echo "Source: $NAME
552 Section: $SECTION
553 Priority: optional
554 Maintainer: Joe Sixpack <joe@example.org>
555 Build-Depends: debhelper (>= 7)
556 Standards-Version: 3.9.1
557
558 Package: $NAME" > debian/control
559 if [ "$ARCH" = 'all' ]; then
560 echo "Architecture: all" >> debian/control
561 else
562 echo "Architecture: any" >> debian/control
563 fi
564 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
565 echo "Description: $DESCRIPTION" >> debian/control
566
567 test -e debian/compat || echo "7" > debian/compat
568 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
569 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
570 cd - > /dev/null
571 }
572
573 buildsimplenativepackage() {
574 local NAME="$1"
575 local NM
576 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
577 NM="$(echo "$NAME" | cut -c 1-4)"
578 else
579 NM="$(echo "$NAME" | cut -c 1)"
580 fi
581 local ARCH="$2"
582 local VERSION="$3"
583 local RELEASE="${4:-unstable}"
584 local DEPENDENCIES="$5"
585 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
586 If you find such a package installed on your system,
587 something went horribly wrong! They are autogenerated
588 und used only by testcases and surf no other propose…"}"
589
590 local SECTION="${7:-others}"
591 local PRIORITY="${8:-optional}"
592 local FILE_TREE="$9"
593 local COMPRESS_TYPE="${10:-gzip}"
594 local DISTSECTION
595 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
596 DISTSECTION="main"
597 else
598 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
599 fi
600 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
601
602 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
603 mkdir -p $BUILDDIR/debian/source
604 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
605 echo "#!/bin/sh
606 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
607
608 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
609 echo "$NAME ($VERSION) $RELEASE; urgency=low
610
611 * Initial release
612
613 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
614 echo "Source: $NAME
615 Priority: $PRIORITY
616 Maintainer: Joe Sixpack <joe@example.org>
617 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
618 if [ "$SECTION" != '<none>' ]; then
619 echo "Section: $SECTION" >> ${BUILDDIR}/debian/control
620 fi
621 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
622 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
623 echo "
624 Package: $NAME" >> ${BUILDDIR}/debian/control
625
626 if [ "$ARCH" = 'all' ]; then
627 echo "Architecture: all" >> ${BUILDDIR}/debian/control
628 else
629 echo "Architecture: any" >> ${BUILDDIR}/debian/control
630 fi
631 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
632 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
633 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
634
635 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
636 cd ${BUILDDIR}/..
637 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
638 cd - >/dev/null
639 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
640 | while read SRC; do
641 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
642 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
643 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
644 # adv --yes --default-key 'Joe Sixpack' \
645 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
646 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
647 # fi
648 done
649
650 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
651 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
652 rm -rf ${BUILDDIR}/debian/tmp
653 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
654 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
655 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
656 if [ -n "$FILE_TREE" ]; then
657 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
658 fi
659
660 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
661 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
662 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
663 # ensure the right permissions as dpkg-deb insists
664 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
665 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/..
666 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
667 done
668
669 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
670 mkdir -p $CHANGEPATH
671 cp ${BUILDDIR}/debian/changelog $CHANGEPATH
672 rm -rf "${BUILDDIR}"
673 msgdone "info"
674 }
675
676 buildpackage() {
677 local BUILDDIR=$1
678 local RELEASE=$2
679 local SECTION=$3
680 local ARCH=$(getarchitecture $4)
681 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
682 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
683 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
684 cd $BUILDDIR
685 if [ "$ARCH" = "all" ]; then
686 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
687 fi
688 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
689 cp ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output $BUILDLOG
690 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
691 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
692 cd - > /dev/null
693 for PKG in $PKGS; do
694 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
695 done
696 for SRC in $SRCS; do
697 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
698 done
699 }
700
701 buildaptarchive() {
702 if [ -d incoming ]; then
703 buildaptarchivefromincoming "$@"
704 else
705 buildaptarchivefromfiles "$@"
706 fi
707 }
708
709 createaptftparchiveconfig() {
710 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
711 local COMPRESSORS="${COMPRESSORS%* }"
712 local ARCHS="$(getarchitectures)"
713 echo -n 'Dir {
714 ArchiveDir "' >> ftparchive.conf
715 echo -n $(readlink -f .) >> ftparchive.conf
716 echo -n '";
717 CacheDir "' >> ftparchive.conf
718 echo -n $(readlink -f ..) >> ftparchive.conf
719 echo -n '";
720 FileListDir "' >> ftparchive.conf
721 echo -n $(readlink -f pool/) >> ftparchive.conf
722 echo -n '";
723 };
724 Default {
725 Packages::Compress "'"$COMPRESSORS"'";
726 Sources::Compress "'"$COMPRESSORS"'";
727 Contents::Compress "'"$COMPRESSORS"'";
728 Translation::Compress "'"$COMPRESSORS"'";
729 LongDescription "false";
730 };
731 TreeDefault {
732 Directory "pool/";
733 SrcDirectory "pool/";
734 };
735 APT {
736 FTPArchive {
737 Release {
738 Origin "joesixpack";
739 Label "apttestcases";
740 Suite "unstable";
741 Description "repository with dummy packages";
742 Architectures "' >> ftparchive.conf
743 echo -n "$ARCHS" >> ftparchive.conf
744 echo 'source";
745 };
746 };
747 };' >> ftparchive.conf
748 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
749 echo -n 'tree "dists/' >> ftparchive.conf
750 echo -n "$DIST" >> ftparchive.conf
751 echo -n '" {
752 Architectures "' >> ftparchive.conf
753 echo -n "$ARCHS" >> ftparchive.conf
754 echo -n 'source";
755 FileList "' >> ftparchive.conf
756 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
757 echo -n '";
758 SourceFileList "' >> ftparchive.conf
759 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
760 echo -n '";
761 Sections "' >> ftparchive.conf
762 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
763 echo '";
764 };' >> ftparchive.conf
765 done
766 }
767
768 buildaptftparchivedirectorystructure() {
769 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
770 for DIST in $DISTS; do
771 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
772 for SECTION in $SECTIONS; do
773 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
774 for ARCH in $ARCHS; do
775 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
776 done
777 mkdir -p dists/${DIST}/${SECTION}/source
778 mkdir -p dists/${DIST}/${SECTION}/i18n
779 done
780 done
781 }
782
783 insertpackage() {
784 local RELEASES="$1"
785 local NAME="$2"
786 local ARCH="$3"
787 local VERSION="$4"
788 local DEPENDENCIES="$5"
789 local PRIORITY="${6:-optional}"
790 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
791 If you find such a package installed on your system,
792 something went horribly wrong! They are autogenerated
793 und used only by testcases and surf no other propose…"}"
794 local ARCHS=""
795 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
796 if [ "$RELEASE" = 'installed' ]; then
797 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
798 continue
799 fi
800 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
801 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
802 ARCHS="$(getarchitectures)"
803 else
804 ARCHS="$arch"
805 fi
806 for BUILDARCH in $ARCHS; do
807 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
808 mkdir -p $PPATH
809 local FILE="${PPATH}/Packages"
810 echo "Package: $NAME
811 Priority: $PRIORITY
812 Section: other
813 Installed-Size: 42
814 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
815 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
816 echo "Version: $VERSION
817 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
818 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
819 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
820 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
821 echo >> $FILE
822 done
823 done
824 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
825 touch aptarchive/dists/${RELEASE}/main/source/Sources
826 echo "Package: $NAME
827 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
828 Description-en: $DESCRIPTION
829 " >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
830 done
831 }
832
833 insertsource() {
834 local RELEASE="$1"
835 local NAME="$2"
836 local ARCH="$3"
837 local VERSION="$4"
838 local DEPENDENCIES="$5"
839 local BINARY="${6:-$NAME}"
840 local ARCHS=""
841 local SPATH="aptarchive/dists/${RELEASE}/main/source"
842 mkdir -p $SPATH
843 local FILE="${SPATH}/Sources"
844 local DSCFILE="${NAME}_${VERSION}.dsc"
845 local TARFILE="${NAME}_${VERSION}.tar.gz"
846 echo "Package: $NAME
847 Binary: $BINARY
848 Version: $VERSION
849 Maintainer: Joe Sixpack <joe@example.org>
850 Architecture: $ARCH" >> $FILE
851 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
852 echo "Files:
853 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
854 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
855 " >> $FILE
856 }
857
858 insertinstalledpackage() {
859 local NAME="$1"
860 local ARCH="$2"
861 local VERSION="$3"
862 local DEPENDENCIES="$4"
863 local PRIORITY="${5:-optional}"
864 local STATUS="${6:-install ok installed}"
865 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
866 If you find such a package installed on your system,
867 something went horribly wrong! They are autogenerated
868 und used only by testcases and surf no other propose…"}"
869
870 local FILE='rootdir/var/lib/dpkg/status'
871 local INFO='rootdir/var/lib/dpkg/info'
872 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
873 echo "Package: $NAME
874 Status: $STATUS
875 Priority: $PRIORITY
876 Section: other
877 Installed-Size: 42
878 Maintainer: Joe Sixpack <joe@example.org>
879 Version: $VERSION" >> $FILE
880 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
881 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
882 echo "Description: $DESCRIPTION" >> $FILE
883 echo >> $FILE
884 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
885 echo -n > ${INFO}/${NAME}:${arch}.list
886 else
887 echo -n > ${INFO}/${NAME}.list
888 fi
889 done
890 }
891
892
893 buildaptarchivefromincoming() {
894 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
895 cd aptarchive
896 [ -e pool ] || ln -s ../incoming pool
897 [ -e ftparchive.conf ] || createaptftparchiveconfig
898 [ -e dists ] || buildaptftparchivedirectorystructure
899 msgninfo "\tGenerate Packages, Sources and Contents files… "
900 testsuccess aptftparchive generate ftparchive.conf
901 cd - > /dev/null
902 msgdone "info"
903 generatereleasefiles "$@"
904 }
905
906 buildaptarchivefromfiles() {
907 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
908 local DIR='aptarchive'
909 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
910 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
911 msgninfo "\t${line} file… "
912 compressfile "$line" "$1"
913 msgdone "info"
914 done
915 generatereleasefiles "$@"
916 }
917
918 compressfile() {
919 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
920 if [ "$compressor" = '.' ]; then
921 if [ -n "$2" ]; then
922 touch -d "$2" "$1"
923 fi
924 continue
925 fi
926 cat "$1" | $command > "${1}.${extension}"
927 if [ -n "$2" ]; then
928 touch -d "$2" "${1}.${extension}"
929 fi
930 done
931 }
932
933 # can be overridden by testcases for their pleasure
934 getcodenamefromsuite() {
935 case "$1" in
936 unstable) echo 'sid';;
937 *) echo -n "$1";;
938 esac
939 }
940 getreleaseversionfromsuite() { true; }
941 getlabelfromsuite() { true; }
942 getoriginfromsuite() { true; }
943
944 generatereleasefiles() {
945 # $1 is the Date header and $2 is the ValidUntil header to be set
946 # both should be given in notation date/touch can understand
947 msgninfo "\tGenerate Release files… "
948 if [ -e aptarchive/dists ]; then
949 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
950 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
951 local CODENAME="$(getcodenamefromsuite $SUITE)"
952 local VERSION="$(getreleaseversionfromsuite $SUITE)"
953 local LABEL="$(getlabelfromsuite $SUITE)"
954 local ORIGIN="$(getoriginfromsuite $SUITE)"
955 if [ -n "$VERSION" ]; then
956 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
957 fi
958 if [ -n "$LABEL" ]; then
959 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
960 fi
961 if [ -n "$ORIGIN" ]; then
962 ORIGIN="-o APT::FTPArchive::Release::Origin=${ORIGIN}"
963 fi
964 aptftparchive -qq release $dir \
965 -o APT::FTPArchive::Release::Suite="${SUITE}" \
966 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
967 ${LABEL} \
968 ${ORIGIN} \
969 ${VERSION} \
970 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
971 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
972 sed -i '/^Date: / a\
973 NotAutomatic: yes' $dir/Release
974 fi
975 if [ -n "$1" -a "$1" != "now" ]; then
976 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
977 fi
978 if [ -n "$2" ]; then
979 sed -i "/^Date: / a\
980 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
981 fi
982 done
983 else
984 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
985 fi
986 if [ -n "$1" -a "$1" != "now" ]; then
987 for release in $(find ./aptarchive -name 'Release'); do
988 touch -d "$1" $release
989 done
990 fi
991 msgdone "info"
992 }
993
994 setupdistsaptarchive() {
995 local APTARCHIVE=$(readlink -f ./aptarchive)
996 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
997 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
998 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
999 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
1000 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
1001 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
1002 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
1003 msgdone "info"
1004 done
1005 }
1006
1007 setupflataptarchive() {
1008 local APTARCHIVE=$(readlink -f ./aptarchive)
1009 if [ -f ${APTARCHIVE}/Packages ]; then
1010 msgninfo "\tadd deb sources.list line… "
1011 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
1012 msgdone "info"
1013 else
1014 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
1015 fi
1016 if [ -f ${APTARCHIVE}/Sources ]; then
1017 msgninfo "\tadd deb-src sources.list line… "
1018 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
1019 msgdone "info"
1020 else
1021 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
1022 fi
1023 }
1024
1025 setupaptarchive() {
1026 local NOUPDATE=0
1027 if [ "$1" = '--no-update' ]; then
1028 NOUPDATE=1
1029 shift
1030 fi
1031 buildaptarchive "$@"
1032 if [ -e aptarchive/dists ]; then
1033 setupdistsaptarchive
1034 else
1035 setupflataptarchive
1036 fi
1037 signreleasefiles 'Joe Sixpack'
1038 if [ "1" != "$NOUPDATE" ]; then
1039 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
1040 fi
1041 }
1042
1043 signreleasefiles() {
1044 local SIGNER="${1:-Joe Sixpack}"
1045 local REPODIR="${2:-aptarchive}"
1046 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
1047 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
1048 msgninfo "\tSign archive with $SIGNER key $KEY… "
1049 local REXKEY='keys/rexexpired'
1050 local SECEXPIREBAK="${REXKEY}.sec.bak"
1051 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1052 if [ "${SIGNER}" = 'Rex Expired' ]; then
1053 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1054 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1055 # therefore we 'temporary' make the key not expired and restore a backup after signing
1056 cp ${REXKEY}.sec $SECEXPIREBAK
1057 cp ${REXKEY}.pub $PUBEXPIREBAK
1058 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1059 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1060 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1061 cp $SECUNEXPIRED ${REXKEY}.sec
1062 cp $PUBUNEXPIRED ${REXKEY}.pub
1063 else
1064 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1065 cat setexpire.gpg
1066 exit 1
1067 fi
1068 cp ${REXKEY}.sec $SECUNEXPIRED
1069 cp ${REXKEY}.pub $PUBUNEXPIRED
1070 fi
1071 fi
1072 for RELEASE in $(find ${REPODIR}/ -name Release); do
1073 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
1074 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
1075 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
1076 # we might have set a specific date for the Release file, so copy it
1077 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
1078 done
1079 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1080 mv -f $SECEXPIREBAK ${REXKEY}.sec
1081 mv -f $PUBEXPIREBAK ${REXKEY}.pub
1082 fi
1083 msgdone "info"
1084 }
1085
1086 redatereleasefiles() {
1087 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1088 for release in $(find aptarchive/ -name 'Release'); do
1089 sed -i "s/^Date: .*$/Date: ${DATE}/" $release
1090 touch -d "$DATE" $release
1091 done
1092 signreleasefiles "${2:-Joe Sixpack}"
1093 }
1094
1095 webserverconfig() {
1096 local WEBSERVER="${3:-http://localhost:8080}"
1097 local NOCHECK=false
1098 if [ "$1" = '--no-check' ]; then
1099 NOCHECK=true
1100 shift
1101 fi
1102 local DOWNLOG='rootdir/tmp/download-testfile.log'
1103 local STATUS='downloaded/webserverconfig.status'
1104 rm -f "$STATUS" "$DOWNLOG"
1105 local URI
1106 if [ -n "$2" ]; then
1107 msgtest "Set webserver config option '${1}' to" "$2"
1108 URI="${WEBSERVER}/_config/set/${1}/${2}"
1109 else
1110 msgtest 'Clear webserver config option' "${1}"
1111 URI="${WEBSERVER}/_config/clear/${1}"
1112 fi
1113 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
1114 msgpass
1115 else
1116 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1117 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1118 msgfailoutput '' "$OUTPUT"
1119 fi
1120 $NOCHECK || testwebserverlaststatuscode '200'
1121 }
1122
1123 rewritesourceslist() {
1124 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
1125 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1126 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
1127 done
1128 }
1129
1130 # wait for up to 10s for a pid file to appear to avoid possible race
1131 # when a helper is started and dosn't write the PID quick enough
1132 waitforpidfile() {
1133 local PIDFILE="$1"
1134 for i in $(seq 10); do
1135 if test -s "$PIDFILE"; then
1136 return 0
1137 fi
1138 sleep 1
1139 done
1140 msgdie "waiting for $PIDFILE failed"
1141 return 1
1142 }
1143
1144 changetowebserver() {
1145 if [ "$1" != '--no-rewrite' ]; then
1146 rewritesourceslist 'http://localhost:8080/'
1147 else
1148 shift
1149 fi
1150 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
1151 cd aptarchive
1152 local LOG="webserver.log"
1153 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
1154 cat $LOG
1155 false
1156 fi
1157 waitforpidfile aptwebserver.pid
1158 local PID="$(cat aptwebserver.pid)"
1159 if [ -z "$PID" ]; then
1160 msgdie 'Could not fork aptwebserver successfully'
1161 fi
1162 addtrap "kill $PID;"
1163 cd - > /dev/null
1164 else
1165 msgdie 'You have to build aptwerbserver or install a webserver'
1166 fi
1167 }
1168
1169 changetohttpswebserver() {
1170 if ! which stunnel4 >/dev/null; then
1171 msgdie 'You need to install stunnel4 for https testcases'
1172 fi
1173 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1174 changetowebserver --no-rewrite "$@"
1175 fi
1176 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1177 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1178 output = /dev/null
1179
1180 [https]
1181 accept = 4433
1182 connect = 8080
1183 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
1184 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1185 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1186 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
1187 if [ -z "$PID" ]; then
1188 msgdie 'Could not fork stunnel4 successfully'
1189 fi
1190 addtrap 'prefix' "kill ${PID};"
1191 rewritesourceslist 'https://localhost:4433/'
1192 }
1193
1194 changetocdrom() {
1195 mkdir -p rootdir/media/cdrom/.disk
1196 local CD="$(readlink -f rootdir/media/cdrom)"
1197 echo "acquire::cdrom::mount \"${CD}\";
1198 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1199 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1200 acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
1201 echo -n "$1" > ${CD}/.disk/info
1202 if [ ! -d aptarchive/dists ]; then
1203 msgdie 'Flat file archive cdroms can not be created currently'
1204 return 1
1205 fi
1206 mv aptarchive/dists "$CD"
1207 ln -s "$(readlink -f ./incoming)" $CD/pool
1208 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1209 # start with an unmounted disk
1210 mv "${CD}" "${CD}-unmounted"
1211 # we don't want the disk to be modifiable
1212 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1213 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1214 }
1215
1216 downloadfile() {
1217 local PROTO="${1%%:*}"
1218 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
1219 download-file "$1" "$2" "$3" 2>&1 ; then
1220 return 1
1221 fi
1222 # only if the file exists the download was successful
1223 if [ -r "$2" ]; then
1224 return 0
1225 else
1226 return 1
1227 fi
1228 }
1229
1230 checkdiff() {
1231 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1232 if [ -n "$DIFFTEXT" ]; then
1233 echo >&2
1234 echo >&2 "$DIFFTEXT"
1235 return 1
1236 else
1237 return 0
1238 fi
1239 }
1240
1241 testfileequal() {
1242 msggroup "$0"
1243 local MSG='Test for correctness of file'
1244 if [ "$1" = '--nomsg' ]; then
1245 MSG=''
1246 shift
1247 fi
1248 local FILE="$1"
1249 shift
1250 if [ -n "$MSG" ]; then
1251 msgtest "$MSG" "$FILE"
1252 fi
1253 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
1254 if [ -z "$*" ]; then
1255 if echo -n "" | checkdiff - $FILE >"$OUTPUT" 2>&1; then
1256 msgpass
1257 else
1258 msgfailoutput '' "$OUTPUT"
1259 fi
1260 else
1261 if echo "$*" | checkdiff - $FILE >"$OUTPUT" 2>&1; then
1262 msgpass
1263 else
1264 msgfailoutput '' "$OUTPUT"
1265 fi
1266 fi
1267 msggroup
1268 }
1269
1270 testempty() {
1271 msggroup "$0"
1272 msgtest "Test for no output of" "$*"
1273 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1274 if "$@" >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1275 msgpass
1276 else
1277 msgfailoutput '' "$COMPAREFILE"
1278 fi
1279 aptautotest 'testempty' "$@"
1280 msggroup
1281 }
1282
1283 testequal() {
1284 msggroup "$0"
1285 local MSG='Test of equality of'
1286 if [ "$1" = '--nomsg' ]; then
1287 MSG=''
1288 shift
1289 fi
1290
1291 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1292 echo "$1" > $COMPAREFILE
1293 shift
1294
1295 if [ -n "$MSG" ]; then
1296 msgtest "$MSG" "$*"
1297 fi
1298 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1299 if "$@" 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
1300 msgpass
1301 else
1302 msgfailoutput '' "$OUTPUT"
1303 fi
1304 aptautotest 'testequal' "$@"
1305 msggroup
1306 }
1307
1308 testequalor2() {
1309 msggroup "$0"
1310 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1311 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1312 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1313 echo "$1" > $COMPAREFILE1
1314 echo "$2" > $COMPAREFILE2
1315 shift 2
1316 msgtest "Test for equality OR of" "$*"
1317 "$@" >$COMPAREAGAINST 2>&1 || true
1318 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1319 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1320 then
1321 msgpass
1322 else
1323 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1324 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1325 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1326 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1327 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1328 msgfailoutput '' "$OUTPUT"
1329 fi
1330 aptautotest 'testequalor2' "$@"
1331 msggroup
1332 }
1333
1334 testshowvirtual() {
1335 msggroup "$0"
1336 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1337 local PACKAGE="$1"
1338 shift
1339 while [ -n "$1" ]; do
1340 VIRTUAL="${VIRTUAL}
1341 N: Can't select versions from package '$1' as it is purely virtual"
1342 PACKAGE="${PACKAGE} $1"
1343 shift
1344 done
1345 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1346 VIRTUAL="${VIRTUAL}
1347 N: No packages found"
1348 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1349 local ARCH="$(getarchitecture 'native')"
1350 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1351 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
1352 if aptcache show -q=0 "$PACKAGE" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
1353 msgpass
1354 else
1355 msgfailoutput '' "$OUTPUT"
1356 fi
1357 msggroup
1358 }
1359
1360 testnopackage() {
1361 msggroup "$0"
1362 msgtest "Test for non-existent packages" "apt-cache show $*"
1363 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1364 if [ -n "$SHOWPKG" ]; then
1365 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1366 echo "$SHOWPKG" >"$OUTPUT"
1367 msgfailoutput '' "$OUTPUT"
1368 else
1369 msgpass
1370 fi
1371 msggroup
1372 }
1373
1374 testdpkgstatus() {
1375 msggroup "$0"
1376 local STATE="$1"
1377 local NR="$2"
1378 shift 2
1379 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1380 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1381 if [ "$PKGS" != $NR ]; then
1382 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1383 echo "$PKGS" >"$OUTPUT"
1384 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1385 msgfailoutput '' "$OUTPUT"
1386 else
1387 msgpass
1388 fi
1389 msggroup
1390 }
1391
1392 testdpkginstalled() {
1393 msggroup "$0"
1394 testdpkgstatus 'ii' "$#" "$@"
1395 msggroup
1396 }
1397
1398 testdpkgnotinstalled() {
1399 msggroup "$0"
1400 testdpkgstatus 'ii' '0' "$@"
1401 msggroup
1402 }
1403
1404 testmarkedauto() {
1405 msggroup "$0"
1406 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1407 if [ -n "$1" ]; then
1408 msgtest 'Test for correctly marked as auto-installed' "$*"
1409 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1410 else
1411 msgtest 'Test for correctly marked as auto-installed' 'no package'
1412 echo -n > $COMPAREFILE
1413 fi
1414 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.output"
1415 if aptmark showauto 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
1416 msgpass
1417 else
1418 msgfailoutput '' "$OUTPUT"
1419 fi
1420 msggroup
1421 }
1422 testmarkedmanual() {
1423 msggroup "$0"
1424 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1425 if [ -n "$1" ]; then
1426 msgtest 'Test for correctly marked as manually installed' "$*"
1427 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1428 else
1429 msgtest 'Test for correctly marked as manually installed' 'no package'
1430 echo -n > $COMPAREFILE
1431 fi
1432 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.output"
1433 if aptmark showmanual 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
1434 msgpass
1435 else
1436 msgfailoutput '' "$OUTPUT"
1437 fi
1438 msggroup
1439 }
1440
1441 msgfailoutput() {
1442 if [ -n "$MSGTEST_MSG" ]; then
1443 echo
1444 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
1445 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
1446 fi
1447 echo -n "$MSGTEST_MSG"
1448 unset MSGTEST_MSG
1449 fi
1450 local MSG="$1"
1451 local OUTPUT="$2"
1452 shift 2
1453 if [ "$1" = 'grep' ]; then
1454 echo >&2
1455 while [ -n "$2" ]; do shift; done
1456 echo "#### Complete file: $1 ####"
1457 cat >&2 "$1" || true
1458 echo '#### grep output ####'
1459 elif [ "$1" = 'test' ]; then
1460 echo >&2
1461 # doesn't support ! or non-file flags
1462 msgfailoutputstatfile() {
1463 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1464 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1465 echo "#### stat(2) of file: $2 ####"
1466 stat "$2" || true
1467 fi
1468 }
1469 msgfailoutputstatfile "$2" "$3"
1470 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1471 shift 3
1472 msgfailoutputstatfile "$2" "$3"
1473 done
1474 echo '#### test output ####'
1475 fi
1476 cat >&2 $OUTPUT
1477 msgfail "$MSG"
1478 }
1479
1480 testsuccess() {
1481 msggroup "$0"
1482 if [ "$1" = '--nomsg' ]; then
1483 shift
1484 else
1485 msgtest 'Test for successful execution of' "$*"
1486 fi
1487 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1488 if "$@" >${OUTPUT} 2>&1; then
1489 if expr match "$1" '^apt.*' >/dev/null; then
1490 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1491 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1492 elif grep -E '^[WE]: ' "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
1493 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1494 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1495 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1496 msgpass
1497 else
1498 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1499 fi
1500 else
1501 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1502 fi
1503 else
1504 msgpass
1505 fi
1506 else
1507 msgpass
1508 fi
1509 else
1510 local EXITCODE=$?
1511 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1512 fi
1513 aptautotest 'testsuccess' "$@"
1514 msggroup
1515 }
1516 testwarning() {
1517 msggroup "$0"
1518 if [ "$1" = '--nomsg' ]; then
1519 shift
1520 else
1521 msgtest 'Test for successful execution with warnings of' "$*"
1522 fi
1523 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1524 if "$@" >${OUTPUT} 2>&1; then
1525 if expr match "$1" '^apt.*' >/dev/null; then
1526 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1527 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1528 elif grep -q -E '^E: ' "$OUTPUT"; then
1529 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1530 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1531 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1532 else
1533 msgpass
1534 fi
1535 else
1536 msgpass
1537 fi
1538 else
1539 local EXITCODE=$?
1540 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1541 fi
1542 aptautotest 'testwarning' "$@"
1543 msggroup
1544 }
1545 testfailure() {
1546 msggroup "$0"
1547 if [ "$1" = '--nomsg' ]; then
1548 shift
1549 else
1550 msgtest 'Test for failure in execution of' "$*"
1551 fi
1552 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1553 if "$@" >${OUTPUT} 2>&1; then
1554 local EXITCODE=$?
1555 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1556 else
1557 local EXITCODE=$?
1558 if expr match "$1" '^apt.*' >/dev/null; then
1559 if [ "$1" = 'aptkey' ]; then
1560 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1561 grep -q -E " BAD signature from " "$OUTPUT"; then
1562 msgpass
1563 else
1564 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1565 fi
1566 else
1567 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1568 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1569 elif grep -q -E '==ERROR' "$OUTPUT"; then
1570 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1571 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1572 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1573 else
1574 msgpass
1575 fi
1576 fi
1577 else
1578 msgpass
1579 fi
1580 fi
1581 aptautotest 'testfailure' "$@"
1582 msggroup
1583 }
1584
1585 testsuccessequal() {
1586 msggroup "$0"
1587 local CMP="$1"
1588 shift
1589 testsuccess "$@"
1590 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$CMP"
1591 msggroup
1592 }
1593 testwarningequal() {
1594 msggroup "$0"
1595 local CMP="$1"
1596 shift
1597 testwarning "$@"
1598 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" "$CMP"
1599 msggroup
1600 }
1601 testfailureequal() {
1602 msggroup "$0"
1603 local CMP="$1"
1604 shift
1605 testfailure "$@"
1606 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" "$CMP"
1607 msggroup
1608 }
1609
1610 testfailuremsg() {
1611 msggroup "$0"
1612 local CMP="$1"
1613 shift
1614 testfailure "$@"
1615 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
1616 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
1617 grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
1618 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.output"
1619 if echo "$CMP" | checkdiff - "${COMPAREFILE}" >"$OUTPUT" 2>&1; then
1620 msgpass
1621 else
1622 echo '### Complete output ###' >"$OUTPUT"
1623 cat "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" >"$OUTPUT"
1624 msgfailoutput '' "$OUTPUT"
1625 fi
1626 msggroup
1627 }
1628
1629 testfilestats() {
1630 msggroup "$0"
1631 msgtest "Test that file $1 has $2 $3" "$4"
1632 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1633 msgpass
1634 else
1635 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1636 {
1637 ls -ld "$1" || true
1638 echo -n "stat(1) reports for $2: "
1639 stat --format "$2" "$1" || true
1640 } >"$OUTPUT" 2>&1
1641 msgfailoutput '' "$OUTPUT"
1642 fi
1643 msggroup
1644 }
1645 testaccessrights() {
1646 msggroup "$0"
1647 testfilestats "$1" '%a' '=' "$2"
1648 msggroup
1649 }
1650
1651 testwebserverlaststatuscode() {
1652 msggroup "$0"
1653 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1654 local STATUS='downloaded/webserverstatus-statusfile.log'
1655 rm -f "$DOWNLOG" "$STATUS"
1656 msgtest 'Test last status code from the webserver was' "$1"
1657 if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1658 msgpass
1659 else
1660 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1661 {
1662 if [ -n "$2" ]; then
1663 shift
1664 echo >&2 '#### Additionally provided output files contain:'
1665 cat >&2 "$@"
1666 fi
1667 echo >&2 '#### Download log of the status code:'
1668 cat >&2 "$DOWNLOG"
1669 } >"$OUTPUT" 2>&1
1670 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
1671 fi
1672 msggroup
1673 }
1674
1675 pause() {
1676 echo "STOPPED execution. Press enter to continue"
1677 local IGNORE
1678 read IGNORE
1679 }
1680
1681 listcurrentlistsdirectory() {
1682 {
1683 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1684 stat --format '%U:%G:%a:%n' "$line"
1685 done
1686 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1687 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1688 done
1689 } | sort
1690 }
1691
1692 ### convenience hacks ###
1693 mkdir() {
1694 # creating some directories by hand is a tedious task, so make it look simple
1695 if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||
1696 [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then
1697 # only the last directory created by mkdir is effected by the -m !
1698 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1699 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1700 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1701 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1702 if [ "$(id -u)" = '0' ]; then
1703 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1704 fi
1705 else
1706 command mkdir "$@"
1707 fi
1708 }
1709
1710 ### The following tests are run by most test methods automatically to check
1711 ### general things about commands executed without writing the test every time.
1712
1713 aptautotest() {
1714 local TESTCALL="$1"
1715 local CMD="$2"
1716 local FIRSTOPT="$3"
1717 local AUTOTEST="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1718 if command -v $AUTOTEST >/dev/null; then
1719 shift 3
1720 # save and restore the *.output files from other tests
1721 # as we might otherwise override them in these automatic tests
1722 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1723 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1724 mkdir ${TMPWORKINGDIRECTORY}/rootdir/tmp
1725 $AUTOTEST "$TESTCALL" "$@"
1726 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1727 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1728 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp-before ${TMPWORKINGDIRECTORY}/rootdir/tmp
1729 fi
1730 }
1731
1732 aptautotest_aptget_update() {
1733 local TESTCALL="$1"
1734 while [ -n "$2" ]; do
1735 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1736 shift
1737 done
1738 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1739 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1740 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1741 # all copied files are properly chmodded
1742 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
1743 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1744 done
1745 if [ "$TESTCALL" = 'testsuccess' ]; then
1746 # failure cases can retain partial files and such
1747 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1748 fi
1749 }
1750 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
1751 aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
1752
1753 testaptautotestnodpkgwarning() {
1754 local TESTCALL="$1"
1755 while [ -n "$2" ]; do
1756 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1757 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
1758 shift
1759 done
1760 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1761 }
1762
1763 aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1764 aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1765 aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1766 aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1767 aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1768 aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }